Index: runtime/plugins/org.jboss.tools.runtime.core/src/org/jboss/tools/runtime/core/JBossRuntimeLocator.java
===================================================================
--- runtime/plugins/org.jboss.tools.runtime.core/src/org/jboss/tools/runtime/core/JBossRuntimeLocator.java	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 43315)
+++ runtime/plugins/org.jboss.tools.runtime.core/src/org/jboss/tools/runtime/core/JBossRuntimeLocator.java	(working copy)
@@ -38,12 +38,12 @@
 	}
 
 	public List<RuntimeDefinition> searchForRuntimes(IPath path, IProgressMonitor monitor) {
-		List<RuntimeDefinition> serverDefinitions = new ArrayList<RuntimeDefinition>();
-		searchForRuntimes(serverDefinitions, path, monitor);
-		return serverDefinitions;
+		List<RuntimeDefinition> collector = new ArrayList<RuntimeDefinition>();
+		searchForRuntimes(collector, path, monitor);
+		return collector;
 	}
 	
-	private void searchForRuntimes(List<RuntimeDefinition> serverDefinitions, IPath path, 
+	private void searchForRuntimes(List<RuntimeDefinition> runtimeCollector, IPath path, 
 			IProgressMonitor monitor) {
 		File[] files = null;
 		if (path != null) {
@@ -63,7 +63,7 @@
 				if (monitor.isCanceled())
 					return;
 				if (files[i] != null && files[i].isDirectory())
-					searchDirectory(files[i], serverDefinitions, DEPTH, monitor);
+					searchDirectory(files[i], runtimeCollector, DEPTH, monitor);
 				monitor.worked(work);
 			}
 			monitor.worked(workLeft);
@@ -73,7 +73,7 @@
 		
 	}
 	
-	public void searchDirectory(File directory, List<RuntimeDefinition> serverDefinitions,
+	public void searchDirectory(File directory, List<RuntimeDefinition> runtimeCollector,
 			int depth, IProgressMonitor monitor) {
 		if (depth == 0 || monitor.isCanceled() || directory == null || !directory.isDirectory()) {
 			return;
@@ -89,9 +89,9 @@
 			if (!detector.isEnabled()) {
 				continue;
 			}
-			RuntimeDefinition serverDefinition = detector.getServerDefinition(directory, monitor);
-			if (serverDefinition != null) {
-				serverDefinitions.add(serverDefinition);
+			RuntimeDefinition runtimeDefinition = detector.getServerDefinition(directory, monitor);
+			if (runtimeDefinition != null) {
+				runtimeCollector.add(runtimeDefinition);
 				return;
 			}
 		}
@@ -106,7 +106,7 @@
 			for (int i = 0; i < size; i++) {
 				if (monitor.isCanceled())
 					return;
-				searchDirectory(files[i], serverDefinitions, depth - 1, monitor);
+				searchDirectory(files[i], runtimeCollector, depth - 1, monitor);
 			}
 		}
 	}
Index: runtime/plugins/org.jboss.tools.runtime.core/src/org/jboss/tools/runtime/core/RuntimeCoreActivator.java
===================================================================
--- runtime/plugins/org.jboss.tools.runtime.core/src/org/jboss/tools/runtime/core/RuntimeCoreActivator.java	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 43315)
+++ runtime/plugins/org.jboss.tools.runtime.core/src/org/jboss/tools/runtime/core/RuntimeCoreActivator.java	(working copy)
@@ -11,6 +11,8 @@
 package org.jboss.tools.runtime.core;
 
 import java.util.ArrayList;
+import java.util.Collections;
+import java.util.Comparator;
 import java.util.List;
 import java.util.Set;
 import java.util.StringTokenizer;
@@ -29,7 +31,9 @@
 import org.eclipse.ui.plugin.AbstractUIPlugin;
 import org.jboss.tools.runtime.core.model.IRuntimeDetector;
 import org.jboss.tools.runtime.core.model.InvalidRuntimeDetector;
+import org.osgi.framework.Bundle;
 import org.osgi.framework.BundleContext;
+import org.osgi.framework.BundleException;
 import org.osgi.service.prefs.BackingStoreException;
 
 /**
@@ -41,34 +45,29 @@
 
 	// The plug-in ID
 	public static final String PLUGIN_ID = "org.jboss.tools.runtime.core"; //$NON-NLS-1$
-	
 	private static final String ESB_DETECTOR_ID = "org.jboss.tools.runtime.handlers.EsbHandler"; //$NON-NLS-1$
-
 	private static final String RUNTIME_DETECTOR_EXTENSION_ID = "org.jboss.tools.runtime.core.runtimeDetectors";
 	
+	// Extension point property keys
 	private static final String NAME = "name";
-
 	private static final String PREFERENCE_ID = "preferenceId";
-	
 	private static final String ID = "id";
-	
 	private static final String ENABLED = "enabled";
+	private static final String PRIORITY = "priority";
 
+	// Preference key
 	private static final String ENABLED_DETECTORS = "enabledDetectors";
 
-	private static final String PRIORITY = "priority";
-
-	private static Set<IRuntimeDetector> declaredRuntimeDetectors;
-	
-	private static Set<IRuntimeDetector> runtimeDetectors;
-	
-	private static IRuntimeDetector esbDetector;
-	
 	// The shared instance
 	private static RuntimeCoreActivator plugin;
 
-	private static IEclipsePreferences prefs;
+	// Member variables
+	private Set<IRuntimeDetector> declaredRuntimeDetectors;
+	private Set<IRuntimeDetector> runtimeDetectors;
+	private IRuntimeDetector esbDetector;
 	
+	private IEclipsePreferences prefs;
+	
 	/**
 	 * The constructor
 	 */
@@ -102,73 +101,102 @@
 		return plugin;
 	}
 
+	public static IRuntimeDetector getEsbDetector() {
+		return getOrLoadDefaultInstance().getEsbDetector2();
+	}
+
+	private static RuntimeCoreActivator getOrLoadDefaultInstance() {
+		if( getDefault() == null ) {
+			// load bundle
+			Bundle bundle = Platform.getBundle(PLUGIN_ID);
+			try {
+				bundle.start();
+			} catch(BundleException be) {
+				be.printStackTrace();
+			}
+		}
+		return getDefault();
+	}
+	// Convenience method
 	public static Set<IRuntimeDetector> getDeclaredRuntimeDetectors() {
-		if (declaredRuntimeDetectors == null) {
-			declaredRuntimeDetectors = new TreeSet<IRuntimeDetector>();
-			IExtensionRegistry registry = Platform.getExtensionRegistry();
-			IExtensionPoint extensionPoint = registry
-					.getExtensionPoint(RUNTIME_DETECTOR_EXTENSION_ID);
-			IExtension[] extensions = extensionPoint.getExtensions();
-			for (int i = 0; i < extensions.length; i++) {
-				IExtension extension = extensions[i];
-				IConfigurationElement[] configurationElements = extension
-						.getConfigurationElements();
-				for (int j = 0; j < configurationElements.length; j++) {
-					IConfigurationElement configurationElement = configurationElements[j];
-					IRuntimeDetector detector;
-					try {
-						detector = (IRuntimeDetector) configurationElement.createExecutableExtension("class");
-					} catch (CoreException e) {
-						log(e);
-						detector = new InvalidRuntimeDetector();
-						detector.setValid(false);
-					}
-					String name = configurationElement.getAttribute(NAME);
-					String preferenceId = configurationElement.getAttribute(PREFERENCE_ID);
-					String id = configurationElement.getAttribute(ID);
-					detector.setName(name);
-					detector.setPreferenceId(preferenceId);
-					detector.setId(id);
-					String enabled = configurationElement.getAttribute(ENABLED);
-					if (enabled == null || "true".equals(enabled)) {
-						detector.setEnabled(true);
-					} else {
-						detector.setEnabled(false);
-					}
-					String priorityString = configurationElement
-							.getAttribute(PRIORITY);
-					int priority;
-					try {
-						priority = Integer.parseInt(priorityString);
-					} catch (Exception ex) {
-						priority = Integer.MAX_VALUE;
-					}
-					detector.setPriority(priority);
-					declaredRuntimeDetectors.add(detector);
-				}
-			}	
+		return getOrLoadDefaultInstance().getDeclaredRuntimeDetectors2();
+	}
+	
+	// Load all declared runtime detectors
+	public Set<IRuntimeDetector> getDeclaredRuntimeDetectors2() {
+		if( declaredRuntimeDetectors == null) {
+			declaredRuntimeDetectors = loadDeclaredRuntimeDetectors();
 		}
 		return declaredRuntimeDetectors;
 	}
 	
-	public static void log(Throwable e) {
-		IStatus status = new Status(IStatus.ERROR, PLUGIN_ID, e
-				.getLocalizedMessage(), e);
-		getDefault().getLog().log(status);
-	}
 	
-	public static void log(Throwable e, String message) {
-		IStatus status = new Status(IStatus.ERROR, PLUGIN_ID, message, e);
-		getDefault().getLog().log(status);
+	// This method will do a full load and actually instantiate the classes
+	public Set<IRuntimeDetector> loadDeclaredRuntimeDetectors() {
+		Set<IRuntimeDetector> declared = new TreeSet<IRuntimeDetector>();
+		IExtensionRegistry registry = Platform.getExtensionRegistry();
+		IExtensionPoint extensionPoint = registry
+				.getExtensionPoint(RUNTIME_DETECTOR_EXTENSION_ID);
+		IExtension[] extensions = extensionPoint.getExtensions();
+		for (int i = 0; i < extensions.length; i++) {
+			IExtension extension = extensions[i];
+			IConfigurationElement[] configurationElements = extension
+					.getConfigurationElements();
+			for (int j = 0; j < configurationElements.length; j++) {
+				IRuntimeDetector dec = loadOneDeclaredRuntimeDetector(configurationElements[j]); 
+				if( !declared.contains(dec)) {
+					declared.add(dec);
+				}
+			}
+		}
+		return declared;
 	}
 
+	// This method will load one detector from a configuration element
+	private IRuntimeDetector loadOneDeclaredRuntimeDetector(IConfigurationElement configurationElement) {
+		IRuntimeDetector detector;
+		try {
+			detector = (IRuntimeDetector) configurationElement.createExecutableExtension("class");
+		} catch (CoreException e) {
+			log(e);
+			detector = new InvalidRuntimeDetector();
+			detector.setValid(false);
+		}
+		String name = configurationElement.getAttribute(NAME);
+		String preferenceId = configurationElement.getAttribute(PREFERENCE_ID);
+		String id = configurationElement.getAttribute(ID);
+		detector.setName(name);
+		detector.setPreferenceId(preferenceId);
+		detector.setId(id);
+		String enabled = configurationElement.getAttribute(ENABLED);
+		if (enabled == null || new Boolean(enabled).booleanValue()) {
+			detector.setEnabled(true);
+		} else {
+			detector.setEnabled(false);
+		}
+		String priorityString = configurationElement
+				.getAttribute(PRIORITY);
+		int priority;
+		try {
+			priority = Integer.parseInt(priorityString);
+		} catch (Exception ex) {
+			priority = Integer.MAX_VALUE;
+		}
+		detector.setPriority(priority);
+		return detector;
+	}
+	
 	public static Set<IRuntimeDetector> getRuntimeDetectors() {
+		return getOrLoadDefaultInstance().getRuntimeDetectors2();
+	}
+	
+	public Set<IRuntimeDetector> getRuntimeDetectors2() {
 		if (runtimeDetectors == null) {
-			runtimeDetectors = getDeclaredRuntimeDetectors();
+			Set<IRuntimeDetector> tmp = getDeclaredRuntimeDetectors();
 			String enabledDetectors = getPreferences().get(ENABLED_DETECTORS,
 					null);
 			if (enabledDetectors == null) {
-				saveEnabledDetectors(runtimeDetectors);
+				saveEnabledDetectors(tmp);
 			} else {
 				StringTokenizer tokenizer = new StringTokenizer(
 						enabledDetectors, ",");
@@ -179,17 +207,18 @@
 						enabled.add(token);
 					}
 				}
-				for (IRuntimeDetector detector : runtimeDetectors) {
+				for (IRuntimeDetector detector : tmp) {
 					detector.setEnabled(enabled.contains(detector.getId()));
 				}
 			}
+			runtimeDetectors = tmp;
 		}
 		return runtimeDetectors;
 	}
 
-	public static void saveEnabledDetectors(Set<IRuntimeDetector> detectors) {
+	public static void saveEnabledDetectors(Set<IRuntimeDetector> allDetectors) {
 		StringBuilder builder = new StringBuilder();
-		for (IRuntimeDetector detector:detectors) {
+		for (IRuntimeDetector detector:allDetectors) {
 			if (detector.isEnabled()) {
 				builder.append(detector.getId());
 				builder.append(",");
@@ -209,13 +238,17 @@
 	}
 	
 	private static IEclipsePreferences getPreferences() {
+		return getOrLoadDefaultInstance().getPreferences2();
+	}
+	
+	private IEclipsePreferences getPreferences2() {
 		if (prefs == null) {
 			prefs = ConfigurationScope.INSTANCE.getNode(PLUGIN_ID);
 		}
 		return prefs;
 	}
-
-	public static IRuntimeDetector getEsbDetector() {
+	
+	public IRuntimeDetector getEsbDetector2() {
 		if (esbDetector == null) {
 			for (IRuntimeDetector detector:getDeclaredRuntimeDetectors()) {
 				if (ESB_DETECTOR_ID.equals(detector.getId())) {
@@ -225,5 +258,15 @@
 		}
 		return esbDetector;
 	}
+	public static void log(Throwable e) {
+		IStatus status = new Status(IStatus.ERROR, PLUGIN_ID, e
+				.getLocalizedMessage(), e);
+		getDefault().getLog().log(status);
+	}
 	
+	public static void log(Throwable e, String message) {
+		IStatus status = new Status(IStatus.ERROR, PLUGIN_ID, message, e);
+		getDefault().getLog().log(status);
+	}
+	
 }
Index: runtime/plugins/org.jboss.tools.runtime.core/src/org/jboss/tools/runtime/core/model/AbstractRuntimeDetector.java
===================================================================
--- runtime/plugins/org.jboss.tools.runtime.core/src/org/jboss/tools/runtime/core/model/AbstractRuntimeDetector.java	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 43315)
+++ runtime/plugins/org.jboss.tools.runtime.core/src/org/jboss/tools/runtime/core/model/AbstractRuntimeDetector.java	(working copy)
@@ -116,17 +116,19 @@
 
 	@Override
 	public int compareTo(IRuntimeDetector o) {
-		if (o == null) {
-			return 1;
-		}
+		if( this.equals(o))
+			return 0;
 		int p1 = this.getPriority();
 		int p2 = o.getPriority();
-		return p1 - p2;
+		int dif = p1 - p2; 
+		if( dif != 0 )
+			return dif;
+		return getId().compareTo(o.getId());
 	}
 
 	@Override
 	public void computeIncludedServerDefinition(
-			RuntimeDefinition serverDefinition) {
+			RuntimeDefinition runtimeDefinition) {
 		
 	}
 	
@@ -139,9 +141,9 @@
 	}
 	
 	@Override
-	public String getVersion(RuntimeDefinition serverDefinition) {
-		if (serverDefinition != null) {
-			return serverDefinition.getVersion();
+	public String getVersion(RuntimeDefinition runtimeDefinition) {
+		if (runtimeDefinition != null) {
+			return runtimeDefinition.getVersion();
 		}
 		return null;
 	}
Index: runtime/plugins/org.jboss.tools.runtime.core/src/org/jboss/tools/runtime/core/model/IRuntimeDetector.java
===================================================================
--- runtime/plugins/org.jboss.tools.runtime.core/src/org/jboss/tools/runtime/core/model/IRuntimeDetector.java	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 43315)
+++ runtime/plugins/org.jboss.tools.runtime.core/src/org/jboss/tools/runtime/core/model/IRuntimeDetector.java	(working copy)
@@ -20,8 +20,33 @@
  *
  */
 public interface IRuntimeDetector extends Comparable<IRuntimeDetector> {
-	void initializeRuntimes(List<RuntimeDefinition> serverDefinitions);
+	/**
+	 * The framework is asking you to create or otherwise initialize 
+	 * the runtimes provided in this list. 
+	 * 
+	 * @param runtimeDefinitions
+	 */
+	void initializeRuntimes(List<RuntimeDefinition> runtimeDefinitions);
 
+	/**
+	 * The framework is asking this detector to search the given folder
+	 * and return a runtime definition, or null if this folder
+	 * is not a recognized runtime
+	 * 
+	 * @param root
+	 * @param monitor
+	 * @return
+	 */
+	RuntimeDefinition getServerDefinition(File root, IProgressMonitor monitor);
+	
+	/**
+	 * The framework is asking you to check nested folders for 
+	 * additional runtimes that may be provided.
+	 * 
+	 * @param runtimeDefinition
+	 */
+	void computeIncludedServerDefinition(RuntimeDefinition runtimeDefinition);
+
 	void setName(String name);
 
 	void setPreferenceId(String preferenceId);
@@ -38,19 +63,17 @@
 	
 	boolean isEnabled();
 	
-	RuntimeDefinition getServerDefinition(File root, IProgressMonitor monitor);
-	
+
 	boolean exists(RuntimeDefinition serverDefinition);
 	
 	int getPriority();
 	
 	void setPriority(int priority);
 	
-	void computeIncludedServerDefinition(RuntimeDefinition serverDefinition);
 	
 	boolean isValid();
 	
 	void setValid(boolean valid);
 	
-	String getVersion(RuntimeDefinition serverDefinition);
+	String getVersion(RuntimeDefinition runtimeDefinition);
 }
Index: runtime/plugins/org.jboss.tools.runtime.ui/src/org/jboss/tools/runtime/ui/JBossRuntimeStartup.java
===================================================================
--- runtime/plugins/org.jboss.tools.runtime.ui/src/org/jboss/tools/runtime/ui/JBossRuntimeStartup.java	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 43315)
+++ runtime/plugins/org.jboss.tools.runtime.ui/src/org/jboss/tools/runtime/ui/JBossRuntimeStartup.java	(working copy)
@@ -52,19 +52,18 @@
 			if (directory.isDirectory()) {
 				RuntimePath runtimePath = new RuntimePath(
 						directory.getAbsolutePath());
-				List<RuntimeDefinition> serverDefinitions = locator
+				List<RuntimeDefinition> runtimeDefinitions = locator
 						.searchForRuntimes(runtimePath.getPath(), monitor);
 				runtimePath.getServerDefinitions().clear();
-				for (RuntimeDefinition serverDefinition : serverDefinitions) {
+				for (RuntimeDefinition serverDefinition : runtimeDefinitions) {
 					serverDefinition.setRuntimePath(runtimePath);
 				}
-				initializeRuntimes(serverDefinitions);
+				initializeRuntimes(runtimeDefinitions);
 			}
 		} catch (IOException e) {
 			RuntimeUIActivator.log(e);
 		}
-		final Set<RuntimePath> runtimePaths = new HashSet<RuntimePath>();
-		parseRuntimeLocationsFile(runtimePaths);
+		final Set<RuntimePath> runtimePaths = parseRuntimeLocationsFile();
 		for (RuntimePath runtimePath : runtimePaths) {
 			List<RuntimeDefinition> serverDefinitions = locator
 					.searchForRuntimes(runtimePath.getPath(), monitor);
@@ -105,8 +104,8 @@
 		});
 	}
 	
-	private static void parseRuntimeLocationsFile(Set<RuntimePath> runtimePaths) {
-		
+	private static Set<RuntimePath> parseRuntimeLocationsFile() {
+		final Set<RuntimePath> runtimePaths = new HashSet<RuntimePath>();
 		try {
 			String pluginLocation = FileLocator.resolve(RuntimeUIActivator.getDefault().getBundle().getEntry("/")).getPath(); //$NON-NLS-1$
 			File serversFile = new File(pluginLocation, LOCATIONS_FILE);
@@ -151,6 +150,7 @@
 		} catch (IOException e) {
 			RuntimeUIActivator.log(e);
 		}
+		return runtimePaths;
 	}
 
 	private static String getConfiguration() throws IOException {
Index: runtime/plugins/org.jboss.tools.runtime.ui/src/org/jboss/tools/runtime/ui/preferences/RuntimePreferencePage.java
===================================================================
--- runtime/plugins/org.jboss.tools.runtime.ui/src/org/jboss/tools/runtime/ui/preferences/RuntimePreferencePage.java	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 43315)
+++ runtime/plugins/org.jboss.tools.runtime.ui/src/org/jboss/tools/runtime/ui/preferences/RuntimePreferencePage.java	(working copy)
@@ -65,7 +65,6 @@
 import org.eclipse.swt.widgets.Group;
 import org.eclipse.swt.widgets.Label;
 import org.eclipse.swt.widgets.Link;
-import org.eclipse.swt.widgets.Shell;
 import org.eclipse.swt.widgets.Table;
 import org.eclipse.swt.widgets.TableColumn;
 import org.eclipse.swt.widgets.TableItem;
Index: runtime/tests/org.jboss.tools.runtime.test/META-INF/MANIFEST.MF
===================================================================
--- runtime/tests/org.jboss.tools.runtime.test/META-INF/MANIFEST.MF	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 43315)
+++ runtime/tests/org.jboss.tools.runtime.test/META-INF/MANIFEST.MF	(working copy)
@@ -2,37 +2,14 @@
 Bundle-ManifestVersion: 2
 Bundle-Name: %BundleName
 Bundle-SymbolicName: org.jboss.tools.runtime.test;singleton:=true
+Bundle-Activator: org.jboss.tools.runtime.test.RuntimeTestActivator
 Bundle-Version: 1.4.0.qualifier
 Require-Bundle: org.eclipse.core.runtime,
  org.junit;bundle-version="4.8.1",
  org.jboss.tools.runtime.ui,
  org.jboss.tools.runtime.core,
  org.jboss.tools.tests,
- org.jboss.tools.seam.core,
- org.eclipse.datatools.connectivity,
- org.eclipse.datatools.connectivity.db.generic,
- org.jboss.tools.common,
- org.jboss.tools.tests,
- org.jboss.ide.eclipse.as.core,
- org.eclipse.wst.server.core,
- org.eclipse.datatools.enablement.hsqldb,
- org.eclipse.datatools.enablement.hsqldb.dbdefinition,
- org.eclipse.datatools.enablement.hsqldb.ui,
- org.eclipse.jst.jee,
- org.eclipse.jst.jee.ejb,
- org.eclipse.jst.jee.ui,
- org.eclipse.jst.jee.web,
- org.eclipse.ui,
- org.eclipse.core.resources,
- org.jboss.tools.jsf.vpe.seam,
- org.jboss.tools.seam.pages.xml,
- org.jboss.tools.seam.ui,
- org.jboss.tools.seam.ui.pages,
- org.jboss.tools.seam.xml,
- org.jboss.tools.seam.xml.ui,
- org.jboss.tools.seam.text.ext,
- org.jboss.tools.runtime.as.detector,
- org.jboss.tools.runtime.seam.detector
+ org.jboss.tools.common
 Bundle-ActivationPolicy: lazy
 Bundle-RequiredExecutionEnvironment: JavaSE-1.6
 Bundle-Vendor: %BundleVendor
Index: runtime/tests/org.jboss.tools.runtime.test/src/org/jboss/tools/runtime/test/RuntimeDetectionFrameworkTest.java
===================================================================
--- runtime/tests/org.jboss.tools.runtime.test/src/org/jboss/tools/runtime/test/RuntimeDetectionFrameworkTest.java	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 0)
+++ runtime/tests/org.jboss.tools.runtime.test/src/org/jboss/tools/runtime/test/RuntimeDetectionFrameworkTest.java	(working copy)
@@ -0,0 +1,146 @@
+/*************************************************************************************
+ * Copyright (c) 2011 Red Hat, Inc. and others.
+ * All rights reserved. This program and the accompanying materials 
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ * 
+ * Contributors:
+ *     JBoss by Red Hat - Initial implementation.
+ ************************************************************************************/
+package org.jboss.tools.runtime.test;
+
+import java.io.File;
+import java.util.List;
+import java.util.Set;
+
+import junit.framework.TestCase;
+
+import org.eclipse.core.runtime.IPath;
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.NullProgressMonitor;
+import org.eclipse.core.runtime.Platform;
+import org.jboss.tools.runtime.core.JBossRuntimeLocator;
+import org.jboss.tools.runtime.core.RuntimeCoreActivator;
+import org.jboss.tools.runtime.core.model.AbstractRuntimeDetector;
+import org.jboss.tools.runtime.core.model.IRuntimeDetector;
+import org.jboss.tools.runtime.core.model.InvalidRuntimeDetector;
+import org.jboss.tools.runtime.core.model.RuntimeDefinition;
+import org.jboss.tools.runtime.core.model.RuntimePath;
+import org.jboss.tools.runtime.handlers.TestHandler1;
+import org.jboss.tools.runtime.ui.RuntimeUIActivator;
+import org.junit.After;
+import org.junit.Before;
+import org.junit.BeforeClass;
+import org.junit.Test;
+import org.osgi.framework.Bundle;
+import org.osgi.framework.BundleException;
+
+/**
+ * 
+ * @author rob stryker
+ * 
+ */
+public class RuntimeDetectionFrameworkTest extends TestCase {
+	private final static String seamVersionAttributeName = "Seam-Version";
+
+	@BeforeClass
+	public static void create() {
+		RuntimeCoreActivator.getDefault();
+		RuntimeUIActivator.getDefault();
+	}
+
+	@Test
+	public void testInvalidDetectors() {
+		Set<IRuntimeDetector> detectors = RuntimeCoreActivator.getDeclaredRuntimeDetectors();
+		IRuntimeDetector invalidDetector = null;
+		for (IRuntimeDetector detector:detectors) {
+			if (detector instanceof InvalidRuntimeDetector) {
+				invalidDetector = detector;
+			}
+		}
+		assertFalse("Invalid detector is enabled.", invalidDetector.isEnabled());
+	}
+	
+	private String displayRuntimes(Set<RuntimePath> paths) {
+		String s = "";
+		for(RuntimePath path:paths) {
+			s += path.getPath() + "\n";
+		}
+		return s;
+	}
+	
+	@Test
+	public void testLoadSaveRuntimePaths() {
+		String path = "test/path/one";
+		Set<RuntimePath> runtimePaths = RuntimeUIActivator.getDefault().getRuntimePaths();
+		assertEquals(displayRuntimes(runtimePaths), 0, runtimePaths.size());
+		RuntimePath runtimePath = new RuntimePath(path);
+		runtimePath.setScanOnEveryStartup(false);
+		runtimePaths.add(runtimePath);
+		RuntimeUIActivator.getDefault().saveRuntimePaths();
+		restartBundle();
+		runtimePaths = RuntimeUIActivator.getDefault().getRuntimePaths();
+		assertEquals(1, runtimePaths.size());
+		runtimePaths.clear();
+		RuntimeUIActivator.getDefault().saveRuntimePaths();
+		restartBundle();
+		runtimePaths = RuntimeUIActivator.getDefault().getRuntimePaths();
+		assertEquals(0, runtimePaths.size());
+	}
+	
+	private void restartBundle() {
+		Bundle bundle = Platform.getBundle(RuntimeUIActivator.PLUGIN_ID);
+		try {
+			// reload prefs
+			bundle.stop();
+			bundle.start();
+		} catch(BundleException be) {
+			
+		}
+	}
+	
+	@Before
+	public void setUp() {
+		IPath stateLoc = RuntimeTestActivator.getDefault().getStateLocation();
+		stateLoc.append("a").toFile().mkdirs();
+		stateLoc.append("b").toFile().mkdirs();
+		stateLoc.append("c").toFile().mkdirs();
+	}
+	
+	@After
+	public void tearDown() {
+		IPath stateLoc = RuntimeTestActivator.getDefault().getStateLocation();
+		stateLoc.append("a").toFile().delete();
+		stateLoc.append("b").toFile().delete();
+		stateLoc.append("c").toFile().delete();
+	}
+	
+	@Test
+	public void testInitializationPaths() {
+		IPath p = RuntimeTestActivator.getDefault().getStateLocation();
+		String path = p.toFile().getAbsolutePath();
+		
+		// Create our path
+		RuntimePath runtimePath = new RuntimePath(path);
+		JBossRuntimeLocator locator = new JBossRuntimeLocator();
+		
+		// Use the locator to find our runtime defs.
+		List<RuntimeDefinition> runtimeDefinitions = locator
+				.searchForRuntimes(runtimePath.getPath(), new NullProgressMonitor());
+		assertEquals(3, runtimeDefinitions.size());
+		
+		
+		// initialize them
+		Set<IRuntimeDetector> detectors = RuntimeCoreActivator.getRuntimeDetectors();
+		for( IRuntimeDetector detector:detectors) {
+			if (detector.isEnabled()) {
+				detector.initializeRuntimes(runtimeDefinitions);
+			}
+		}
+		
+		String[] initialized = TestHandler1.getInstance().getInited();
+		assertEquals(3, initialized.length);
+		
+	}
+}
Index: runtime/tests/org.jboss.tools.runtime.test/src/org/jboss/tools/runtime/test/RuntimeTestActivator.java
===================================================================
--- runtime/tests/org.jboss.tools.runtime.test/src/org/jboss/tools/runtime/test/RuntimeTestActivator.java	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 0)
+++ runtime/tests/org.jboss.tools.runtime.test/src/org/jboss/tools/runtime/test/RuntimeTestActivator.java	(working copy)
@@ -0,0 +1,45 @@
+package org.jboss.tools.runtime.test;
+
+import org.eclipse.core.runtime.Plugin;
+import org.osgi.framework.BundleContext;
+
+public class RuntimeTestActivator extends Plugin {
+
+	// The shared instance
+	private static RuntimeTestActivator plugin;
+	
+	
+	/**
+	 * The constructor
+	 */
+	public RuntimeTestActivator() {
+	}
+
+	/*
+	 * (non-Javadoc)
+	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
+	 */
+	public void start(BundleContext context) throws Exception {
+		super.start(context);
+		plugin = this;
+	}
+
+	/*
+	 * (non-Javadoc)
+	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
+	 */
+	public void stop(BundleContext context) throws Exception {
+		plugin = null;
+		super.stop(context);
+	}
+
+	/**
+	 * Returns the shared instance
+	 *
+	 * @return the shared instance
+	 */
+	public static RuntimeTestActivator getDefault() {
+		return plugin;
+	}
+
+}
